apiVersion: kustomize.config.k8s.io/v1beta1
kind: Kustomization
resources:
  - https://github.com/kubernetes-sigs/cluster-api/releases/download/v1.5.3/core-components.yaml
# Unfornately vars can't be used to set EXP_CLUSTER_RESOURCE_SET, as it only allows to pass an object...
patches:
  - target:
      group: apps
      version: v1
      kind: Deployment
      name: capi-controller-manager
      namespace: capi-system
    patch: |-
      - op: replace
        path: /spec/template/spec/containers/0/args/2
        value: --feature-gates=MachinePool=false,ClusterResourceSet=false,ClusterTopology=false
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: clusterclasses.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: clusterresourcesetbindings.addons.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: clusterresourcesets.addons.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: clusters.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: machinedeployments.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: machinehealthchecks.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: machinepools.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: machines.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle
  - target:
      group: apiextensions.k8s.io
      version: v1
      kind: CustomResourceDefinition
      name: machinesets.cluster.x-k8s.io
    patch: |-
      - op: remove
        path: /spec/conversion/webhook/clientConfig/caBundle

# We must use a lot of specific remove operations as annotationSelector doesn't support special characters in value
# See: https://github.com/kubernetes-sigs/kustomize/issues/3887
# Otherwise we could have use: annotationSelector: "cert-manager.io/inject-ca-from=capi-system"

# Add labels to enable clusterctl move to retrieve resources correponding to capi CRDs
labels:
  - pairs:
      clusterctl.cluster.x-k8s.io: ""
